<template>
<div>
 <Navbar></Navbar>
     <!-- Liste des posts -->   
      <div v-for="post in posts" :key="post.id" class="listContainer">
          <div class="userContainer">
              <h3><i class="far fa-user-circle"></i> {{ post.user.firstName }} {{ post.user.lastName }} </h3>
              <div class="dateContainer">         
                  <p><i class="far fa-clock"></i> {{ post.createdAt | moment("DD.MM.YY HH:mm") }} </p>
              </div>
          </div>
          <div class="postContainer">
              <h4><i class="fas fa-angle-double-right"></i>  {{ post.title }} </h4>
              <h5 class="post"><i class="fas fa-angle-right"></i>"  {{ post.content }} "</h5>
          </div>  
          <div class="actionsContainer">
                <button v-if="post.userId == userId || isAdmin == true" 
                type="button" @click="deletePost(post.id)" class="aprofil_button">Supprimer 😢 </button>
          </div>
       
        
      </div>   
  </div>

</template>

<script>
import Navbar from '../components/Navbar'
export default {
    name: "PostList",
    components: {
        Navbar
    },

    data() {
        return {
            firstName: "",
            lastName: "",           
            userId: "",
            isAdmin: "",
            posts: []
        }
    },
    mounted() {
        this.userId = JSON.parse(sessionStorage.getItem("userId"));
        this.isAdmin = JSON.parse(sessionStorage.getItem("isAdmin"));
        console.log(sessionStorage);


        let url = "http://localhost:3000/api/posts/postList";
        let options = {
            method: "GET",
            headers: {
                'Authorization': 'Bearer ' + sessionStorage.getItem("token"),
            }
        };
        fetch(url, options)
            .then(response => response.json())
            .then(data => {
                console.log(data)
                this.postList = data;
                console.log(this.postList)
            })
            .catch(error => console.log(error))
    },

    methods: {
        // suppression des posts
        deletePost(postid) {
            let url = `http://localhost:3000/api/posts/delete/${ postid }`;
            let options = {
                method: "DELETE",
                headers: {
                    'Authorization': 'Bearer ' + sessionStorage.getItem("token"),
                }
            };
            fetch(url, options)
                .then((response) => {
                    console.log(response);
                    alert("Suppression du message confirmé ! 😭");
                    window.location.reload();
                })
                .catch(error => console.log(error))
        },
    },
}
</script>

<style lang="css">
.listContainer {
  width: 70%;
  margin: auto;
  margin-top: 25px;
  background-image: url("../assets/backpost.jpg");
  background-repeat: no-repeat;
  background-size: cover;
  border-radius: 30px; 
  padding: 25px;
}
h4 {
  text-transform: uppercase;
  font-size: 1.25em;
  text-decoration: underline;
   
}
.dateContainer {
  display: flex;
  flex-direction: row;
  margin: auto;
  width: 50%;
  justify-content: space-around;
  
}
.userContainer i {
  color: #0c2444;
  font-size: 1.75em;
  
}
.actionsContainer {
  width: 90%;
  margin: 0 auto;
  flex-direction: row;
}
.actionsContainer button {
  margin-bottom: 10px;
}
.userContainer {
  width: 90%;
  background-color: grey;
  margin: 0 auto;
  border-radius: 30px; 
  display: flex; 
  flex-direction: row;
  align-items: center;
  justify-content: space-evenly;
  color: white;
}
.userContainer h3 {
  font-size: 1.5em;
  margin: auto;
  padding-left: 15px;
  width: 50%;
}
.postContainer {
  width: 90%;
  margin: 0 auto;
  border-radius: 30px; 
  border: 6px solid grey;
  box-sizing: content-box;
  text-align: center;
}
.postContainer  h5 {
  font-style: italic;
}
h5 i, h4 i {
  font-size: 2em;
  color: #0c2444;
}
@media screen and (max-width: 450px) {
	.listContainer {
    width: 90%; 
    box-shadow: inset 0px 0px 0px 8px white;
    border: 5px solid #d44c5c;
    font-size: 0.7em;
  }
  .form-group {
    display: flex;
    flex-direction: column;
    
  }
  label, input, textarea {
    width: 75%;
    text-align: center;
  }
}
</style>